function init()
    RegisterTool("atomizer", "Atomizer", "MOD/vox/atomizer.vox")
    SetBool("game.tool.atomizer.enabled", true)
    snd = LoadSound("MOD/snd/shoot.ogg")
end

function tick(dt)
    if InputPressed("usetool") and GetString("game.player.tool") == "atomizer" then
        local hit, dist, normal, shape = QueryRaycast(GetPlayerCameraTransform().pos, TransformToParentVec(GetPlayerCameraTransform(), Vec(0, 0, -1)), 25)
        if hit and IsBodyDynamic(GetShapeBody(shape)) then
            PlaySound(snd)
            local xs, ys, zs = GetShapeSize(shape)
            vel = GetBodyVelocity(GetShapeBody(shape))

            gunEndPos = TransformToParentPoint(GetBodyTransform(GetToolBody()), Vec(0.55, -0.4, -1.6))
            pos = VecAdd(GetPlayerCameraTransform().pos, VecScale(TransformToParentVec(GetPlayerCameraTransform(), Vec(0, 0, -1)), dist))
            for j=1, 100 do
                ParticleReset()
                ParticleTile(6)
                ParticleRadius(0.03)
                ParticleColor(0, 1, 1)
                ParticleEmissive(2)
                ParticleCollide(0)
                SpawnParticle(VecLerp(gunEndPos, pos, j / 100), VecLerp(GetPlayerVelocity(), vel, j / 100), 0.2)
            end

            for x = 1, xs do
                for y = 1, ys do
                    for z = 1, zs do
                        local mat, r, g, b, a = GetShapeMaterialAtIndex(shape, x - 1, y - 1, z - 1)
                        if (r + g + b) > 0 then
                            ParticleReset()
                            ParticleTile(6)
                            ParticleRadius(0.06, 0.01)
                            ParticleGravity(0)
                            ParticleColor(r, g, b)
                            ParticleAlpha(a, 0)
                            SpawnParticle(TransformToParentPoint(GetShapeWorldTransform(shape), Vec((x - 0.5) / 10, (y - 0.5) / 10, (z - 0.5) / 10)), vel, 1)
                        end
                    end
                end
            end
            Delete(shape)
        end
    end
end